/* putbyte.h -- Copyright 1989, 1993 Liam R. E. Quin.  All Rights Reserved.
 * This code is NOT in the public domain.
 * See the file COPYRIGHT for full details.
 */

/* $Id: putbyte.h,v 1.2 93/09/12 17:17:37 lee Exp $
 *
 */


/* PutByte gets called literally millions of times, so it is a macro.
 * The idea is that if we reach the end of the block, PutByte calls _PutByte
 * which fetches a new block and sets offset pointers, blocklength, etc.,
 * and resets the char * pointers to point into the right buffer.
 */
#define PutByte(Byte,WID,sp,Blockp,BlockLength,LastStart,NextBlock,NextSize) \
    ( (*(sp) - (unsigned char *) *(Blockp) >= *(BlockLength)) ? \
       _PutByte(Byte,WID,sp,Blockp,BlockLength,LastStart,NextBlock,NextSize) : \
      ((*((*(sp))++) = (Byte)), 0))

#define PutLong(L,WID,sp,Blockp,BlockLength,LastStart,NextBlock,NextSize) \
    (((L) < 128) ? \
	PutByte((L),WID,sp,Blockp,BlockLength,LastStart,NextBlock,NextSize) \
		: \
	_PutLong(L,WID,sp,Blockp,BlockLength,LastStart,NextBlock,NextSize) \
    )

