/* GetFID.c -- Copyright 1989, 1993 Liam R. Quin.  All Rights Reserved.
 * This code is NOT in the public domain.
 * See the file COPYRIGHT for full details.
 */

/* GetFID.c -- get the largest current word number
 * 
 * $Id: GetFID.c,v 1.2 93/11/28 15:15:08 lee Exp $
 */

#include "globals.h" /* defines and declarations for database filenames */
#include "error.h"

#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>

#include "fileinfo.h"
#include "wordinfo.h"
#include "block0.h"

/** declarations: **/
/** Unix system calls that need to be declared: **/

/** Unix Library Calls that need to be declared: **/

/** lq-text calls that need to be declared: **/
extern unsigned char *ReadBlock();

/** **/
#ifdef ASCIITRACE
 extern int AsciiTrace;
#endif

API t_FID
GetMaxFID()
{
    extern t_FID LastNextFIDVal;
    unsigned char *p;
    t_FID Result;

    p = ReadBlock(0L);

    Result = (t_FID) p[BLOCK_ZERO_MAXFID0]; /* most significant byte */
    Result <<= 8; Result |= (t_FID) p[BLOCK_ZERO_MAXFID1];
    Result <<=8; Result |= (t_FID) p[BLOCK_ZERO_MAXFID2];
    Result <<=8; Result |= (t_FID) p[BLOCK_ZERO_MAXFID3];

    if (!Result) {
	Result = 1;
    }

    if (Result > LastNextFIDVal) {
	LastNextFIDVal = Result;
    } else if (LastNextFIDVal > Result) {
	Result = GetNextFID(1);
	if (Result > LastNextFIDVal) {
	    LastNextFIDVal = Result;
	} else if (Result != LastNextFIDVal) {
	    Error(E_BUG,
		"GetMaxFID confused between %ld and %ld",
		Result, LastNextFIDVal
	    );
	}
    }
#ifdef ASCIITRACE
    if (AsciiTrace > 3) {
	fprintf(stderr, "GetMaxFID --> %d\n", Result);
    }
#endif
    return Result;
}

